<template>
  <bubble-menu
    v-if="editorRef"
    :editor="editorRef"
    plugin-key="tableRowMenu"
    :should-show="shouldShowRowMenu"
    :update-delay="0"
    :tippy-options="{ 
      offset: [0, 15],
      placement: 'auto-start',
      popperOptions: {
        modifiers: [{ name: 'flip', enabled: false }],
      },
      appendTo: () => {
        return elementTarget
      },
    }"
  >
  <div id="tableRowMenu" class="w-[220px] max-h-[496px] rounded-[4px] py-2 h-full flex flex-col bg-surface cardShadow">
    <v-list
      color="primary"
      density="compact"
      class="!py-0 w-full"
    >
      <v-list-item
        v-for="(item, index) in items"
        :key="item.value"
        :value="item.value"
        :active="false"
        @click="item?.onClick()"
      >
        <div class="w-full flex gap-3 whitespace-nowrap">
          <div>
            <Icon
              :icon="item?.icon"
              height="24"
              width="24"
              :class="item?.iconClass"
            />
          </div>
  
          <svn-pro-text
            regular
            bodyLarge
            class="truncate text-ellipsis"
            :color="index === items?.length - 1 ? 'error' : 'onSurface'"
          >
            {{ item.title }}
          </svn-pro-text>
        </div>
      </v-list-item>
    </v-list>
  </div>
  </bubble-menu>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import { watch, ref, onMounted } from 'vue';
import { Editor, BubbleMenu } from '@tiptap/vue-3';
import SvnProText from '../../styles/SvnProText.vue';
import { isRowGripSelected } from '../utils/isRowGripSelected.js';

onMounted(() => {
  editorRef.value = props.editor;
});

const props = defineProps({
  editor: { type: Editor, default: () => {}, required: true },
  elementTarget: { type: undefined, default: null },
});

const editorRef = ref(null);

const shouldShowRowMenu = ({ view, state, from }) => {
  if (!props.editor.state) {
    return false
  }

  return isRowGripSelected({ editor: props.editor, view, state, from: from || 0 });
}

const onAddRowBefore = () => {
  props.editor.chain().focus().addRowBefore().run();
}

const onAddRowAfter = () => {
  props.editor.chain().focus().addRowAfter().run();
}

const onDeleteRow = () => {
  props.editor.chain().focus().deleteRow().run();
}

const items = [
  {
    value: "add_before",
    title: "Add row before",
    icon: "mingcute:arrow-to-left-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => onAddRowBefore()
  },
  {
    value: "add_after",
    title: "Add row after",
    icon: "mingcute:arrow-to-right-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => onAddRowAfter()
  },
  {
    value: "delete_row",
    title: "Delete row",
    icon: "mingcute:delete-2-line",
    iconClass: "text-error",
    onClick: () => onDeleteRow()
  },
]

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
});
</script>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>